/*
From hplabs!sdcrdcf!sdcsvax!dcdwest!ittatc!decvax!mcnc!rti-sel!scirtp!dfh Sun Aug 25 12:55:29 1985
Relay-Version: version B 2.10.2 9/18/84; site amdahl.UUCP
Posting-Version: version B 2.10.2 9/5/84; site scirtp.UUCP
Path: amdahl!hplabs!sdcrdcf!sdcsvax!dcdwest!ittatc!decvax!mcnc!rti-sel!scirtp!dfh
From: dfh@scirtp.UUCP (David F. Hinnant)
Newsgroups: net.sources
Subject: Whetstone Benchmark source in C - enclosed
Message-ID: <353@scirtp.UUCP>
Date: 25 Aug 85 19:55:29 GMT
Date-Received: 27 Aug 85 08:15:18 GMT
Distribution: net
Organization: SCI Systems, Research Triangle Park, NC
Lines: 252

Enclosed below is a C translation of the famous "Whetstone Benchmark"
from the original Algol version.  I have inserted printf()'s as a
compiler option.  I think this translation is accurate.  The only
numbers I have to compare with are from an old Ridge-32 machine, and
these are from a Pascal translation (I caught one error in their
translation).  If anyone has any nunbers from FORTRAN, Pascal, or Algol
versions of the Whetstone, I would very much like to see them.

				David Hinnant
				SCI Systems, Inc.
				{decvax, akgua}!mcnc!rti-sel!scirtp!dfh


P.s., there is a .signature file at the end of the listing. */

/*
 *      Whetstone benchmark in C.  This program is a translation of the
 *	original Algol version in "A Synthetic Benchmark" by H.J. Curnow
 *      and B.A. Wichman in Computer Journal, Vol  19 #1, February 1976.
 *
 *	Used to test compiler optimization and floating point performance.
 *
 *	Compile by:		cc -O -s -o whet whet.c
 *	or:				cc -O -DPOUT -s -o whet whet.c
 *	if output is desired.
 */

/*

	gp@ : whet [<JԂ>]

		<JԂ> : ̫ 10

Microsoft (R) C Optimizing Compiler Version 5.10 / 6.00A / 7.0A, Visual C++ 1.0

cl /Ot /J /Zp  whet.c /link /st:0x2800/cp:0x1000
cl /Ot /J /Zpl whet.c /link slibcr+libh/st:0x2800/cp:0x1000

Turbo C  Version 2.0 / Turbo C++  Version 1.0

tcc whet.c

Borland C++  Version 3.00

bcc whet.c

LSI C-86 Ver 3.30

lcc whet.c -ltinymain.obj ( out of memoryź߲قłȂ )

	PC-9801BA (i486DX2 40MHz) ł̌
цц
		߲		EXE 	Whetstone				
ކކ
Borland C++ 3.00	28786	޲Ć4385.96 Kwhets/second	
ކކ
Turbo C++ 1.0		28786	޲Ć4629.63 Kwhets/second	
ކކ
MS-C/C++ 7.0A		29567	޲Ć4854.37 Kwhets/second	
ކކ
VC++ 1.00			31345	޲Ć4854.37 Kwhets/second	
نن

*/

#define ITERATIONS	5000 /* 1 Million Whetstone instructions */

#ifndef MSDOS
#define MSDOS
#endif
#ifdef MSDOS
#include <math.h>
#else
#include "sane.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#ifndef MSDOS
// #Options G H
#endif

/*#define POUT*/
#define Pout(n, j, k, x1, x2, x3, x4) timingOff;\
pout(n, j, k, x1, x2, x3, x4);timingOn;

#ifndef MSDOS
#define double extended
#endif

#ifdef MSDOS
#ifdef	_WIN32
#include <windows.h>
#define timingOn  ( ticks -= GetTickCount() )
#define timingOff ( ticks += GetTickCount() )
#else
#include <time.h>
#ifdef POUT
#define timingOn { time_t t; time(&t); ticks -= t; }
#else
#define timingOn { time_t t; for ( time(&t); t == time(NULL); ); ticks -= t+1; }
#endif
#define timingOff { time_t t; time(&t); ticks += t; }
#endif
#else
#define tickCount *((long *)0x16A)
#define timingOn ticks -= tickCount
#define timingOff ticks += tickCount
#endif

double		xx1, xx2, xx3, xx4, x, y, z, t, t1, t2;
double 		e1[4];
long		i, j, k, l, n1, n2, n3, n4, n6, n7, n8, n9, n10, n11;

long ticks;

#ifdef	_CONSOLE
int main(argc, argv)
int argc;
char *argv[];
#else
int Whetstone(Kwhets)
double *Kwhets;
#endif
{
	long iterations = ITERATIONS;

#ifdef	_CONSOLE
	if ( argc >= 2 )
		iterations = atol( *++argv );
	printf("\nWhetstone Benchmark\n\n");
#endif

	ticks = 0;

	timingOn;

	/* initialize constants */
   	
	t   =   0.499975;
	t1  =   0.50025;
	t2  =   2.0;

	/* set values of module weights */

	n1  =   0 * iterations;
	n2  =  12 * iterations;
	n3  =  14 * iterations;
	n4  = 345 * iterations;
	n6  = 210 * iterations;
	n7  =  32 * iterations;
	n8  = 899 * iterations;
	n9  = 616 * iterations;
	n10 =   0 * iterations;
	n11 =  93 * iterations;

/* MODULE 1:  simple identifiers */

	xx1 =  1.0;
	xx2 = xx3 = xx4 = -1.0;

	for(i = 1; i <= n1; i += 1) {
		xx1 = ( xx1 + xx2 + xx3 - xx4 ) * t;
		xx2 = ( xx1 + xx2 - xx3 - xx4 ) * t;
		xx3 = ( xx1 - xx2 + xx3 + xx4 ) * t;
		xx4 = (-xx1 + xx2 + xx3 + xx4 ) * t;
	}
#ifdef POUT
	Pout(n1, n1, n1, xx1, xx2, xx3, xx4);
#endif


/* MODULE 2:  array elements */

	e1[0] =  1.0;
	e1[1] = e1[2] = e1[3] = -1.0;

	for (i = 1; i <= n2; i +=1) {
		e1[0] = ( e1[0] + e1[1] + e1[2] - e1[3] ) * t;
		e1[1] = ( e1[0] + e1[1] - e1[2] + e1[3] ) * t;
		e1[2] = ( e1[0] - e1[1] + e1[2] + e1[3] ) * t;
		e1[3] = (-e1[0] + e1[1] + e1[2] + e1[3] ) * t;
	}
#ifdef POUT
	Pout(n2, n3, n2, e1[0], e1[1], e1[2], e1[3]);
#endif

/* MODULE 3:  array as parameter */

	for (i = 1; i <= n3; i += 1)
		pa(e1);
#ifdef POUT
	Pout(n3, n2, n2, e1[0], e1[1], e1[2], e1[3]);
#endif

/* MODULE 4:  conditional jumps */

	j = 1;
	for (i = 1; i <= n4; i += 1) {
		if (j == 1)
			j = 2;
		else
			j = 3;

		if (j > 2)
			j = 0;
		else
			j = 1;

		if (j < 1 )
			j = 1;
		else
			j = 0;
	}
#ifdef POUT
	Pout(n4, j, j, xx1, xx2, xx3, xx4);
#endif

/* MODULE 5:  omitted */

/* MODULE 6:  integer arithmetic */

	j = 1;
	k = 2;
	l = 3;

	for (i = 1; i <= n6; i += 1) {
		j = j * (k - j) * (l -k);
		k = l * k - (l - j) * k;
		l = (l - k) * (k + j);

		e1[l - 2] = j + k + l;		/* C arrays are zero based */
		e1[k - 2] = j * k * l;
	}
#ifdef POUT
	Pout(n6, j, k, e1[0], e1[1], e1[2], e1[3]);
#endif

/* MODULE 7:  trig. functions */

	x = y = 0.5;

	for(i = 1; i <= n7; i +=1) {
		x = t * atan(t2*sin(x)*cos(x)/(cos(x+y)+cos(x-y)-1.0));
		y = t * atan(t2*sin(y)*cos(y)/(cos(x+y)+cos(x-y)-1.0));
	}
#ifdef POUT
	Pout(n7, j, k, x, x, y, y);
#endif

/* MODULE 8:  procedure calls */

	x = y = z = 1.0;

	for (i = 1; i <= n8; i +=1)
		p3(x, y, &z);
#ifdef POUT
	Pout(n8, j, k, x, y, z, z);
#endif

/* MODULE9:  array references */

	j = 1;
	k = 2;
	l = 3;

	e1[0] = 1.0;
	e1[1] = 2.0;
	e1[2] = 3.0;

	for(i = 1; i <= n9; i += 1)
		p0();
#ifdef POUT
	Pout(n9, j, k, e1[0], e1[1], e1[2], e1[3]);
#endif

/* MODULE10:  integer arithmetic */

	j = 2;
	k = 3;

	for(i = 1; i <= n10; i +=1) {
		j = j + k;
		k = j + k;
		j = k - j;
		k = k - j - j;
	}
#ifdef POUT
	Pout(n10, j, k, xx1, xx2, xx3, xx4);
#endif

/* MODULE11:  standard functions */

	x = 0.75;
	for(i = 1; i <= n11; i +=1)
		x = sqrt( exp( log(x) / t1));

#ifdef POUT
	Pout(n11, j, k, x, x, x, x);
#endif
  
  timingOff;
#ifdef	_CONSOLE
#ifdef MSDOS
#ifdef	_WIN32
  printf("\nWhetstone runs in %lu msec. %0.2f Kwhets/second\n", 
  		ticks, ticks ? (1000.0 * 100.0 * (double)iterations) / ticks : 0);
#else
  printf("\nWhetstone runs in %lu seconds. %0.2f Kwhets/second\n", 
  		ticks, ticks ? (100.0 * (double)iterations) / ticks : 0);
#endif
#else
  printf("\nWhetstone runs in %0.2f seconds. %0.2f Kwhets/second\n", 
  		ticks/60.0, (60.0 * 100.0 * (double)iterations) / ticks);
#endif
#else
#ifdef	_WIN32
  *Kwhets = ticks ? (1000.0 * 100.0 * (double)iterations) / ticks : 0;
#else
  *Kwhets = ticks ? (100.0 * (double)iterations) / ticks : 0;
#endif
#endif
  return(0);
}

pa(e)
double e[4];
{
	register long j;

	j = 0;
     lab:
	e[0] = (  e[0] + e[1] + e[2] - e[3] ) * t;
	e[1] = (  e[0] + e[1] - e[2] + e[3] ) * t;
	e[2] = (  e[0] - e[1] + e[2] + e[3] ) * t;
	e[3] = ( -e[0] + e[1] + e[2] + e[3] ) / t2;
	j += 1;
	if (j < 6)
		goto lab;
}


p3(x, y, z)
double x, y, *z;
{
	x  = t * (x + y);
	y  = t * (x + y);
	*z = (x + y) /t2;
}


p0()
{
	e1[j] = e1[k];
	e1[k] = e1[l];
	e1[l] = e1[j];
}

#ifdef POUT
pout(n, j, k, x1, x2, x3, x4)
long n, j, k;
double x1, x2, x3, x4;
{
	printf("%5ld %5ld %5ld   %11.3e %11.3e %11.3e %11.3e\n",
		n, j, k, x1, x2, x3, x4);
}
#endif

/*
=======================================================================
-- 
				David Hinnant
				SCI Systems, Inc.
				{decvax, akgua}!mcnc!rti-sel!scirtp!dfh

*/
